'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _url = require('url');

var _url2 = _interopRequireDefault(_url);

var _utils = require('../utils');

var _keys = require('../utils/keys');

var _keys2 = _interopRequireDefault(_keys);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Types = require('./embeds');

function getDomain(link) {
  var a = _url2.default.parse(link);
  return a.hostname;
}

var Embed = {
  Name: 'embed',
  Icon: '',
  Empty: function Empty() {
    return {
      url: '',
      subtext: '',
      meta: {}
    };
  },
  maximumBlocks: 0,
  Description: 'Embed',
  isEmpty: function isEmpty(content) {
    return content === '';
  },
  EmbedTypes: Types
};

var BlockEmbed = function (_React$Component) {
  _inherits(BlockEmbed, _React$Component);

  function BlockEmbed(props) {
    _classCallCheck(this, BlockEmbed);

    var _this = _possibleConstructorReturn(this, (BlockEmbed.__proto__ || Object.getPrototypeOf(BlockEmbed)).call(this, props));

    _this.state = {
      loaded: false,
      domain: '',
      url: '',
      className: ''
    };

    _this.getClassName = _this.getClassName.bind(_this);
    _this.checkUrls = _this.checkUrls.bind(_this);
    _this.handleUrl = _this.handleUrl.bind(_this);
    _this.checkContent = _this.checkContent.bind(_this);
    _this.renderBlock = _this.renderBlock.bind(_this);
    _this.changeSubtext = _this.changeSubtext.bind(_this);
    _this.updateMeta = _this.updateMeta.bind(_this);
    _this.onDrop = _this.onDrop.bind(_this);
    _this.onDragEnter = _this.onDragEnter.bind(_this);
    _this.onDragOver = _this.onDragOver.bind(_this);
    _this.onDragLeave = _this.onDragLeave.bind(_this);
    return _this;
  }

  _createClass(BlockEmbed, [{
    key: 'getClassName',
    value: function getClassName() {
      return 'katap-block katap-embed ' + (this.props.className || this.state.className);
    }
  }, {
    key: 'checkUrls',
    value: function checkUrls(url, isProp) {
      if (url.indexOf('http') < 0) {
        url = 'https://' + url;
      }
      if (_utils.UrlRegex.test(url)) {
        var domain = getDomain(url);
        var Types = this.props.EmbedTypes;
        for (var key in Types) {
          if (domain.indexOf(key) > -1) {
            this.setState({
              loaded: true,
              domain: key,
              url: url
            });
            return;
          }
        }
        alert('This URL is not supported.');
        this.refs.input.value = '';
      } else {
        if (!isProp) {
          alert("Enter a valid url");
          this.refs.input.value = '';
        }
      }
      _utils.UrlRegex.lastIndex = 0;
    }
  }, {
    key: 'handleUrl',
    value: function handleUrl(event) {
      if (event.keyCode === _keys2.default.ENTER) {
        this.checkUrls(event.target.value, false);
      }
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      if (this.props.content.url === '') {
        this.refs.input.focus();
      }
      this.checkUrls(this.props.content.url, true);
    }
  }, {
    key: 'checkContent',
    value: function checkContent(ok, msg) {
      if (ok && this.props.onContentChanged) {
        var newData = this.props.content;
        newData.url = this.state.url;
        this.props.onContentChanged(this.props.position, newData);
      } else {
        alert(msg);
      }
    }
  }, {
    key: 'changeSubtext',
    value: function changeSubtext(e) {
      if (this.props.onContentChanged) {
        var newContent = this.props.content;
        newContent.subtext = e.target.value;
        //console.log(newContent);
        this.props.onContentChanged(this.props.position, newContent);
      }
    }
  }, {
    key: 'updateMeta',
    value: function updateMeta(newMeta) {
      var newContent = this.props.content;
      newContent.meta = newMeta;
      this.props.onContentChanged(this.props.position, newContent);
    }
  }, {
    key: 'onDragEnter',
    value: function onDragEnter(e) {
      e.preventDefault();
      e.stopPropagation();
      this.setState({
        className: 'katap-embed-dragover'
      });
    }
  }, {
    key: 'onDragOver',
    value: function onDragOver(e) {
      e.preventDefault();
      e.stopPropagation();
      e.dataTransfer.dropEffect = 'move';
      return false;
    }
  }, {
    key: 'onDrop',
    value: function onDrop(e) {
      if (e.preventDefault) e.preventDefault();
      if (e.stopPropagation) e.stopPropagation();
      this.setState({
        className: ''
      });
      var dropURL = e.dataTransfer.getData("URL");
      if (dropURL === "") {
        dropURL = e.dataTransfer.getData("text");
      }
      if (dropURL !== "") {
        this.checkUrls(dropURL, false);
      }
    }
  }, {
    key: 'onDragLeave',
    value: function onDragLeave(e) {
      this.setState({
        className: 'katap-block katap-embed'
      });
    }
  }, {
    key: 'renderBlock',
    value: function renderBlock() {
      var Types = this.props.EmbedTypes;
      var EmbedType = Types[this.state.domain];
      return _react2.default.createElement(EmbedType, {
        url: this.state.url,
        checkContent: this.checkContent,
        content: this.props.content,
        updateMeta: this.updateMeta });
    }
  }, {
    key: 'render',
    value: function render() {
      var content = this.props.content;
      if (this.state.loaded) {
        return _react2.default.createElement(
          'div',
          { className: 'katap-block' },
          this.renderBlock(),
          _react2.default.createElement('input', {
            type: 'text',
            placeholder: 'Embed subtext',
            onChange: this.changeSubtext,
            value: content.subtext })
        );
      } else {
        return _react2.default.createElement(
          'div',
          {
            className: this.getClassName(),
            onDragEnter: this.onDragEnter,
            onDragOver: this.onDragOver,
            onDragLeave: this.onDragLeave,
            onDrop: this.onDrop },
          _react2.default.createElement(
            'p',
            null,
            'Drop links here or paste below'
          ),
          _react2.default.createElement('input', {
            ref: 'input',
            type: 'text',
            placeholder: 'Enter URL and press enter',
            onKeyUp: this.handleUrl }),
          _react2.default.createElement(
            'p',
            null,
            'Supported embeds: ',
            Object.keys(this.props.EmbedTypes).join(', ')
          )
        );
      }
    }
  }]);

  return BlockEmbed;
}(_react2.default.Component);

BlockEmbed.defaultProps = {
  EmbedTypes: Types
};

Embed.React = BlockEmbed;

exports.default = Embed;