'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _base = require('./base');

var _base2 = _interopRequireDefault(_base);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Facebook = function (_BaseEmbed) {
  _inherits(Facebook, _BaseEmbed);

  function Facebook(props) {
    _classCallCheck(this, Facebook);

    var _this = _possibleConstructorReturn(this, (Facebook.__proto__ || Object.getPrototypeOf(Facebook)).call(this, props));

    _this.state = {
      message: 'Wait',
      id: '',
      valid: false,
      html: ''
    };
    _this.validate = _this.validate.bind(_this);
    _this.loadExternalScript = _this.loadExternalScript.bind(_this);
    return _this;
  }

  _createClass(Facebook, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.validate();
    }
  }, {
    key: 'showPreview',
    value: function showPreview() {
      this.setState({
        preview: !this.state.preview
      });
      this.loadExternalScript();
    }
  }, {
    key: 'loadExternalScript',
    value: function loadExternalScript() {
      if (window.FB && window.FB.init) {
        window.FB.init({
          xfbml: true,
          version: 'v2.3'
        });
        return;
      }
      var tag = document.createElement('script');
      tag.src = this.props.scriptUrl;
      tag.async = 1;
      window.document.body.appendChild(tag);
    }
  }, {
    key: 'validate',
    value: function validate() {
      var match;
      match = this.props.regex.exec(this.props.url);
      this.props.regex.lastIndex = 0;
      if (!match) {
        this.props.checkContent(false);
        this.setState({
          message: 'error.'
        });
        return;
      }
      var html = '<div class="fb-post" data-href="' + this.props.url + '" data-width="750"></div>';
      if (this.props.url.indexOf('/videos/') > 0) {
        html = '<div class="fb-video" data-href="' + this.props.url + '" data-allowfullscreen="true" data-width="750"></div>';
      }
      this.setState({
        message: 'Loading Facebook embed...',
        id: match[1],
        valid: true,
        html: html
      });
      this.props.checkContent(true);
    }
  }, {
    key: 'render',
    value: function render() {
      if (this.state.valid) {
        if (!this.state.preview) {
          return _react2.default.createElement(
            'div',
            { className: 'katap-embed katap-facebook' },
            _react2.default.createElement(
              'p',
              null,
              'Facebook - ',
              _react2.default.createElement(
                'a',
                { href: this.props.url, target: '_blank' },
                this.props.url
              )
            ),
            _react2.default.createElement(
              'button',
              { className: 'katap-show-preview-btn', onClick: this.showPreview },
              'Preview'
            )
          );
        }
        return _react2.default.createElement('div', {
          className: 'katap-embed katap-facebook',
          dangerouslySetInnerHTML: { __html: this.state.html } });
      }
      return _react2.default.createElement(
        'div',
        { className: 'katap-embed katap-twitter' },
        'This fb URL is not supported.'
      );
    }
  }]);

  return Facebook;
}(_base2.default);

Facebook.defaultProps = {
  url: '',
  regex: /https?:\/\/www\.facebook\.com\/(?:.*)\/(videos|posts|photos)\/(\d+).*/gi,
  scriptUrl: '//connect.facebook.net/en_US/sdk.js#xfbml=1&version=v2.3'
};

exports.default = Facebook;