'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _base = require('./base');

var _base2 = _interopRequireDefault(_base);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Vine = function (_BaseEmbed) {
  _inherits(Vine, _BaseEmbed);

  function Vine(props) {
    _classCallCheck(this, Vine);

    var _this = _possibleConstructorReturn(this, (Vine.__proto__ || Object.getPrototypeOf(Vine)).call(this, props));

    _this.loadExternalScript = _this.loadExternalScript.bind(_this);
    return _this;
  }

  _createClass(Vine, [{
    key: 'loadExternalScript',
    value: function loadExternalScript() {
      var scriptUrl = this.props.scriptUrl;
      var tag = document.createElement('script');
      tag.src = scriptUrl;
      tag.async = 1;
      window.document.body.appendChild(tag);
    }
  }, {
    key: 'extraHandler',
    value: function extraHandler() {
      this.loadExternalScript();
    }
  }, {
    key: 'render',
    value: function render() {
      if (this.state.valid) {
        if (!this.state.preview) {
          return _react2.default.createElement(
            'div',
            { className: 'katap-embed katap-vine' },
            _react2.default.createElement(
              'p',
              null,
              'Vine - ',
              _react2.default.createElement(
                'a',
                { href: this.props.url, target: '_blank' },
                this.props.url
              )
            ),
            _react2.default.createElement(
              'button',
              { className: 'katap-show-preview-btn', onClick: this.showPreview },
              'Preview'
            )
          );
        }

        return _react2.default.createElement(
          'div',
          { className: 'katap-embed katap-vine' },
          _react2.default.createElement('iframe', {
            className: 'vine-embed',
            src: '//vine.co/v/' + this.state.id + '/embed/postcard',
            frameBorder: 0,
            width: 600,
            height: 600,
            allowFullScreen: true })
        );
      }
      return _react2.default.createElement(
        'div',
        { className: 'katap-embed' },
        'Invalid Vimeo URL.'
      );
    }
  }]);

  return Vine;
}(_base2.default);

Vine.defaultProps = {
  regex: /https?:\/\/vine\.co\/v\/([a-zA-Z0-9].*)\/?/,
  scriptUrl: '//platform.vine.co/static/scripts/embed.js'
};

exports.default = Vine;