'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _droppable = require('../components/droppable');

var _droppable2 = _interopRequireDefault(_droppable);

var _keys = require('../utils/keys');

var _keys2 = _interopRequireDefault(_keys);

var _utils = require('../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var BlockImage = function (_React$Component) {
  _inherits(BlockImage, _React$Component);

  function BlockImage(props) {
    _classCallCheck(this, BlockImage);

    var _this = _possibleConstructorReturn(this, (BlockImage.__proto__ || Object.getPrototypeOf(BlockImage)).call(this, props));

    _this.handleImage = _this.handleImage.bind(_this);
    _this.changeItem = _this.changeItem.bind(_this);
    _this.handleKeyPress = _this.handleKeyPress.bind(_this);
    _this.imageLoaded = _this.imageLoaded.bind(_this);
    return _this;
  }

  _createClass(BlockImage, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var content = this.props.content;
      if (!content || content.url === "") {
        this.refs.img.focus();
      }
    }
  }, {
    key: 'handleImage',
    value: function handleImage(files) {
      var _this2 = this;

      var newContent = this.props.content;
      this.props.onFilesAdded(files, function (url) {
        if (url && url !== '') {
          newContent.url = url;
          _this2.props.onContentChanged(_this2.props.position, newContent);
        }
      }, function (err) {
        alert('Error while uploading files.');
      });
    }
  }, {
    key: 'changeItem',
    value: function changeItem(key, e) {
      if (this.props.onContentChanged) {
        var newContent = this.props.content;
        newContent[key] = e.target.value;
        this.props.onContentChanged(this.props.position, newContent);
      }
    }
  }, {
    key: 'handleKeyPress',
    value: function handleKeyPress(e) {
      if (e.which === _keys2.default.ENTER) {
        if (_utils.UrlRegex.test(e.target.value)) {
          var newContent = {};
          newContent.subtext = this.props.content.subtext;
          newContent.url = e.target.value;
          if (this.props.onContentChanged) {
            this.props.onContentChanged(this.props.position, newContent);
          }
        } else {
          alert('Enter a valid URL.');
        }
        _utils.UrlRegex.lastIndex = 0;
      }
    }
  }, {
    key: 'imageLoaded',
    value: function imageLoaded(e) {
      if (e.target.src.indexOf('blob:') === 0) {
        URL.revokeObjectURL(e.target.src);
      } else {
        var newContent = this.props.content;
        newContent.width = e.target.naturalWidth;
        newContent.height = e.target.naturalHeight;
        this.props.onContentChanged(this.props.position, newContent);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var content = this.props.content;
      return _react2.default.createElement(
        'div',
        { className: 'katap-block katap-image' },
        !content || content.url === '' ? _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement('input', {
            ref: 'img',
            type: 'text',
            placeholder: 'Paste URL of image and press enter',
            onKeyDown: this.handleKeyPress }),
          _react2.default.createElement(
            _droppable2.default,
            {
              onDrop: this.handleImage },
            _react2.default.createElement(
              'p',
              null,
              this.props.message
            )
          )
        ) : _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement('img', { src: content.url, onLoad: this.imageLoaded }),
          _react2.default.createElement('input', {
            type: 'text',
            className: 'katap-image-subtext',
            placeholder: 'Image subtext',
            onChange: this.changeItem.bind(this, 'subtext'),
            value: content.subtext }),
          _react2.default.createElement('input', {
            type: 'text',
            className: 'katap-image-subtext',
            placeholder: 'Hyperlink',
            onChange: this.changeItem.bind(this, 'hyperlink'),
            value: content.hyperlink })
        )
      );
    }
  }]);

  return BlockImage;
}(_react2.default.Component);

BlockImage.defaultProps = {
  message: 'Or Drop image here or click to add.',
  onFilesAdded: function onFilesAdded(files) {
    console.log(files);
  }
};

var Image = {
  Name: 'image',
  React: BlockImage,
  Icon: '',
  Empty: function Empty() {
    return {
      url: '',
      subtext: '',
      hyperlink: ''
    };
  },
  maximumBlocks: 0,
  Description: 'Image',
  isEmpty: function isEmpty(content) {
    return content.url === '';
  }
};

exports.default = Image;