'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _action = require('../utils/action');

var _action2 = _interopRequireDefault(_action);

var _listitem = require('../components/listitem');

var _listitem2 = _interopRequireDefault(_listitem);

var _blockcontrol = require('../components/blockcontrol');

var _blockcontrol2 = _interopRequireDefault(_blockcontrol);

var _utils = require('../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var BlockOL = function (_React$Component) {
  _inherits(BlockOL, _React$Component);

  function BlockOL(props) {
    _classCallCheck(this, BlockOL);

    var _this = _possibleConstructorReturn(this, (BlockOL.__proto__ || Object.getPrototypeOf(BlockOL)).call(this, props));

    _this.onContentChanged = _this.onContentChanged.bind(_this);
    _this.addItem = _this.addItem.bind(_this);
    _this.handleItemRemove = _this.handleItemRemove.bind(_this);
    _this.renderListItem = _this.renderListItem.bind(_this);
    return _this;
  }

  _createClass(BlockOL, [{
    key: 'onContentChanged',
    value: function onContentChanged(position, content) {
      this.props.content[position].content = content;
      if (this.props.onContentChanged) {
        this.props.onContentChanged(this.props.position, this.props.content);
      }
    }
  }, {
    key: 'addItem',
    value: function addItem(position) {
      if (position < 0 || position >= this.props.content.length) {
        return;
      }
      var content = this.props.content;
      content.splice(position + 1, 0, {
        content: '<p><br></p>',
        key: (0, _utils.uuid)()
      });
      if (this.props.onContentChanged) {
        this.props.onContentChanged(this.props.position, content);
      }
    }
  }, {
    key: 'handleItemRemove',
    value: function handleItemRemove(action, position) {
      // if(this.props.content.length < 2) {
      //   return;
      // }
      var content = this.props.content;
      content.splice(position, 1);
      if (this.props.onContentChanged) {
        this.props.onContentChanged(this.props.position, content);
      }
    }
  }, {
    key: 'renderListItem',
    value: function renderListItem() {
      var self = this;
      var li = [];
      this.props.content.map(function (item, index) {
        li.push(_react2.default.createElement(
          'li',
          { key: item.key },
          _react2.default.createElement(_blockcontrol2.default, {
            onlyRemove: true,
            blockAction: self.handleItemRemove,
            position: index,
            className: 'katap-list-block-control',
            length: self.props.content.length }),
          _react2.default.createElement(_listitem2.default, {
            position: index,
            content: item.content,
            addItem: self.addItem,
            onContentChanged: self.onContentChanged })
        ));
      });
      return li;
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        'ol',
        { className: 'katap-block katap-list' },
        this.renderListItem()
      );
    }
  }]);

  return BlockOL;
}(_react2.default.Component);

var OL = {
  Name: 'ol',
  React: BlockOL,
  Icon: '',
  Empty: function Empty() {
    return [{
      content: '<p><br></p>',
      key: (0, _utils.uuid)()
    }];
  },
  maximumBlocks: 0,
  Description: 'Ordered List',
  isEmpty: function isEmpty(content) {
    for (var i = 0; i < content.length; i++) {
      if (content[i].content.replace(/(<([^>]+)>)/ig, '') !== '') {
        return false;
      }
    }
    return true;
  }
};

BlockOL.defaultProps = {
  content: OL.Empty()
};

exports.default = OL;