'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _scribeOptions = require('../components/scribe-options');

var _text = require('./text');

var _text2 = _interopRequireDefault(_text);

var _scribe = require('../components/scribe');

var _scribe2 = _interopRequireDefault(_scribe);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var BlockQuote = function (_BlockText$React) {
  _inherits(BlockQuote, _BlockText$React);

  function BlockQuote(props) {
    _classCallCheck(this, BlockQuote);

    var _this = _possibleConstructorReturn(this, (BlockQuote.__proto__ || Object.getPrototypeOf(BlockQuote)).call(this, props));

    _this.onContentChanged = _this.onContentChanged.bind(_this);
    _this.onCreditChange = _this.onCreditChange.bind(_this);
    return _this;
  }

  _createClass(BlockQuote, [{
    key: 'onContentChanged',
    value: function onContentChanged(content) {
      var content = {
        content: content,
        credit: this.props.content.credit
      };
      if (this.props.onContentChanged) {
        this.props.onContentChanged(this.props.position, content);
      }
    }
  }, {
    key: 'onCreditChange',
    value: function onCreditChange(e) {
      var content = {
        content: this.props.content.content,
        credit: e.target.value
      };
      if (this.props.onContentChanged) {
        this.props.onContentChanged(this.props.position, content);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        'blockquote',
        { className: 'katap-block katap-text' },
        _react2.default.createElement(_scribe2.default, {
          options: _scribeOptions.baseOptions,
          content: this.props.content.content,
          onContentChanged: this.onContentChanged }),
        _react2.default.createElement('input', {
          className: 'katap-blockquote-credit',
          type: 'text',
          placeholder: 'Credit',
          onChange: this.onCreditChange,
          value: this.props.content.credit })
      );
    }
  }]);

  return BlockQuote;
}(_text2.default.React);

var Quote = {
  Name: 'quote',
  React: BlockQuote,
  Icon: '',
  Empty: function Empty() {
    return {
      content: '<p><br></p>',
      credit: ''
    };
  },
  maximumBlocks: 0,
  Description: 'Block Quote',
  isEmpty: function isEmpty(content) {
    return content['content'].replace(/(<([^>]+)>)/ig, '') === '';
  }
};

BlockQuote.defaultProps = {
  content: Quote.Empty()
};

exports.default = Quote;