'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _scribe = require('../components/scribe');

var _scribe2 = _interopRequireDefault(_scribe);

var _scribeOptions = require('../components/scribe-options');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var BlockText = function (_React$Component) {
  _inherits(BlockText, _React$Component);

  function BlockText(props) {
    _classCallCheck(this, BlockText);

    var _this = _possibleConstructorReturn(this, (BlockText.__proto__ || Object.getPrototypeOf(BlockText)).call(this, props));

    _this.captureReturn = _this.captureReturn.bind(_this);
    _this.onContentChanged = _this.onContentChanged.bind(_this);
    _this.splitBlock = _this.splitBlock.bind(_this);
    return _this;
  }

  _createClass(BlockText, [{
    key: 'captureReturn',
    value: function captureReturn() {
      this.props.addBlock("text", this.props.position);
    }
  }, {
    key: 'onContentChanged',
    value: function onContentChanged(content) {
      if (this.props.onContentChanged) {
        this.props.onContentChanged(this.props.position, content);
      }
    }
  }, {
    key: 'splitBlock',
    value: function splitBlock(e) {
      this.props.splitBlock(this.props.position);
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        'div',
        { className: 'katap-block katap-text' },
        _react2.default.createElement(
          'div',
          { className: 'katap-toolbar-wrapper katap-clearfix' },
          _react2.default.createElement(
            'button',
            {
              className: 'katap-splitter',
              onClick: this.splitBlock,
              title: 'Click to split this block. Content should be separated by a new line.'
            },
            '</>'
          )
        ),
        _react2.default.createElement(_scribe2.default, {
          content: this.props.content,
          options: _scribeOptions.baseTextOptions,
          onContentChanged: this.onContentChanged })
      );
    }
  }]);

  return BlockText;
}(_react2.default.Component);

var Text = {
  Name: 'text',
  React: BlockText,
  Icon: '',
  Empty: function Empty() {
    return '<p><br></p>';
  },
  maximumBlocks: 0,
  Description: 'Text',
  isEmpty: function isEmpty(content) {
    return content.replace(/(<([^>]+)>)/ig, '') === '';
  }
};

exports.default = Text;