'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _action = require('../utils/action');

var _action2 = _interopRequireDefault(_action);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var BlockControl = function (_React$Component) {
  _inherits(BlockControl, _React$Component);

  function BlockControl(props) {
    _classCallCheck(this, BlockControl);

    var _this = _possibleConstructorReturn(this, (BlockControl.__proto__ || Object.getPrototypeOf(BlockControl)).call(this, props));

    _this.handleClick = _this.handleClick.bind(_this);
    _this.getToolbar = _this.getToolbar.bind(_this);
    return _this;
  }

  _createClass(BlockControl, [{
    key: 'handleClick',
    value: function handleClick(e) {
      var nodes = Array.prototype.slice.call(e.currentTarget.children);
      var index = nodes.indexOf(e.target);
      if (index < 0) {
        return;
      }
      var action = nodes[index].getAttribute("data-action");
      this.props.blockAction(action, this.props.position);
    }
  }, {
    key: 'getToolbar',
    value: function getToolbar(index) {
      if (this.props.onlyRemove) {
        return _react2.default.createElement(
          'div',
          {
            className: this.props.className,
            onClick: this.handleClick },
          _react2.default.createElement(
            'button',
            { title: 'Remove', 'data-action': _action2.default.REMOVE, key: _action2.default.REMOVE },
            '\xD7'
          )
        );
      }
      var buttons = [];
      if (index === 0 && this.props.length < 2) {
        buttons.push(_react2.default.createElement(
          'button',
          { title: 'Delete', 'data-action': _action2.default.REMOVE, key: _action2.default.REMOVE },
          '\xD7'
        ));
      } else if (index === 0) {
        buttons.push(_react2.default.createElement(
          'button',
          { title: 'Delete', 'data-action': _action2.default.REMOVE, key: _action2.default.REMOVE },
          '\xD7'
        ));
        buttons.push(_react2.default.createElement(
          'button',
          { title: 'Move Down', 'data-action': _action2.default.DOWN, key: _action2.default.DOWN },
          '\u2193'
        ));
      } else if (index === this.props.length - 1) {
        buttons.push(_react2.default.createElement(
          'button',
          { title: 'Delete', 'data-action': _action2.default.REMOVE, key: _action2.default.REMOVE },
          '\xD7'
        ));
        buttons.push(_react2.default.createElement(
          'button',
          { title: 'Move Up', 'data-action': _action2.default.UP, key: _action2.default.UP },
          '\u2191'
        ));
      } else {
        buttons.push(_react2.default.createElement(
          'button',
          { title: 'Delete', 'data-action': _action2.default.REMOVE, key: _action2.default.REMOVE },
          '\xD7'
        ));
        buttons.push(_react2.default.createElement(
          'button',
          { title: 'Move Up', 'data-action': _action2.default.UP, key: _action2.default.UP },
          '\u2191'
        ));
        buttons.push(_react2.default.createElement(
          'button',
          { title: 'Move Down', 'data-action': _action2.default.DOWN, key: _action2.default.DOWN },
          '\u2193'
        ));
      }
      return _react2.default.createElement(
        'div',
        {
          className: this.props.className,
          onClick: this.handleClick },
        buttons
      );
    }
  }, {
    key: 'render',
    value: function render() {
      return this.getToolbar(this.props.position);
    }
  }]);

  return BlockControl;
}(_react2.default.Component);

BlockControl.defaultProps = {
  onlyRemove: false,
  className: "katap-control-toolbar"
};

exports.default = BlockControl;