'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Droppable = function (_React$Component) {
  _inherits(Droppable, _React$Component);

  function Droppable(props) {
    _classCallCheck(this, Droppable);

    var _this = _possibleConstructorReturn(this, (Droppable.__proto__ || Object.getPrototypeOf(Droppable)).call(this, props));

    _this.state = {
      className: ''
    };
    _this.getClassName = _this.getClassName.bind(_this);
    _this.onDragEnter = _this.onDragEnter.bind(_this);
    _this.onDragOver = _this.onDragOver.bind(_this);
    _this.onDragLeave = _this.onDragLeave.bind(_this);
    _this.onClick = _this.onClick.bind(_this);
    _this.onDrop = _this.onDrop.bind(_this);
    return _this;
  }

  _createClass(Droppable, [{
    key: 'getClassName',
    value: function getClassName() {
      return 'katap-droppable ' + (this.props.className || this.state.className);
    }
  }, {
    key: 'onDragEnter',
    value: function onDragEnter(e) {
      e.preventDefault();
      e.stopPropagation();
      this.setState({
        className: 'katap-drop-active'
      });
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.refs.droppable.focus();
    }
  }, {
    key: 'onDragOver',
    value: function onDragOver(e) {
      e.preventDefault();
      e.stopPropagation();
      e.dataTransfer.dropEffect = 'copy';
      if (this.props.onDragOver) {
        this.props.onDragOver(e);
      }
    }
  }, {
    key: 'onDragLeave',
    value: function onDragLeave(e) {
      this.setState({
        className: ''
      });

      if (this.props.onDragLeave) {
        this.props.onDragLeave(e);
      }
    }
  }, {
    key: 'onClick',
    value: function onClick() {
      var fileInput = this.refs.input;
      fileInput.value = null;
      fileInput.click();
    }
  }, {
    key: 'onDrop',
    value: function onDrop(e) {
      e.preventDefault();
      var files;
      if (e.dataTransfer) {
        files = e.dataTransfer.files;
      } else if (e.target) {
        files = e.target.files;
      }
      var maxFiles = this.props.multiple ? files.length : 1;
      for (var i = 0; i < maxFiles; i++) {
        files[i].preview = URL.createObjectURL(files[i]);
      }
      if (this.props.onDrop) {
        files = Array.prototype.slice.call(files, 0, maxFiles);
        this.props.onDrop(files);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        'div',
        {
          ref: 'droppable',
          style: { height: 100 },
          className: this.getClassName(),
          onDragEnter: this.onDragEnter,
          onDragOver: this.onDragOver,
          onDragLeave: this.onDragLeave,
          onClick: this.onClick,
          onDrop: this.onDrop },
        _react2.default.createElement('input', {
          ref: 'input',
          type: 'file',
          style: { display: 'none' },
          multiple: this.props.multiple,
          onChange: this.onDrop }),
        this.props.children
      );
    }
  }]);

  return Droppable;
}(_react2.default.Component);

Droppable.defaultProps = {
  supportClick: true,
  multiple: false
};

exports.default = Droppable;