'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _mediumEditor = require('medium-editor');

var _mediumEditor2 = _interopRequireDefault(_mediumEditor);

var _keys = require('../utils/keys');

var _keys2 = _interopRequireDefault(_keys);

var _editoroptions = require('../utils/editoroptions');

var _editoroptions2 = _interopRequireDefault(_editoroptions);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var MediumComponent = function (_React$Component) {
  _inherits(MediumComponent, _React$Component);

  function MediumComponent(props) {
    _classCallCheck(this, MediumComponent);

    var _this2 = _possibleConstructorReturn(this, (MediumComponent.__proto__ || Object.getPrototypeOf(MediumComponent)).call(this, props));

    _this2.state = {
      content: props.content
    };

    _this2.dom = null;
    _this2._updated = false;

    _this2.change = _this2.change.bind(_this2);
    _this2.placeCaretAtEnd = _this2.placeCaretAtEnd.bind(_this2);
    _this2.captureReturn = _this2.captureReturn.bind(_this2);
    _this2.handleBeforeInput = _this2.handleBeforeInput.bind(_this2);
    return _this2;
  }

  _createClass(MediumComponent, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this3 = this;

      var _this = this;

      var dom = _reactDom2.default.findDOMNode(this);
      this.dom = dom;
      var options = this.props.options;
      console.log(options);
      this.medium = new _mediumEditor2.default(dom, options);
      // this.medium.setContent(this.state.content);

      this.medium.subscribe('editableKeydown', this.handleBeforeInput);

      if (this.props.enterCapture) {
        this.medium.subscribe('editableKeyup', this.captureReturn);
        this.medium.subscribe('editableInput', function (e) {
          _this3._updated = true;
          _this3.change(dom.innerHTML.replace('<p><br></p>', ''));
        });
      } else {
        this.medium.subscribe('editableInput', function (e) {
          _this3._updated = true;
          _this3.change(dom.innerHTML);
        });
      }

      if (this.state.content === '' || this.state.content === '<p><br></p>') {
        setTimeout(this.placeCaretAtEnd, 0);
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.medium.destroy();
      this.dom = null;
      this.medium = null;
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.content !== this.state.content && !this._updated) {
        this.setState({ content: nextProps.content });
      }

      if (this._updated) this._updated = false;
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps) {
      return false;
    }
  }, {
    key: 'handleBeforeInput',
    value: function handleBeforeInput(e) {
      if (e.ctrlKey || e.metaKey || e.altKey || e.keyCode !== 222) {
        return;
      };
      e.preventDefault();
      var sel = _mediumEditor2.default.selection.getSelectionRange(this.medium.options.ownerDocument);
      if (sel.collapsed && sel.startOffset === sel.endOffset) {
        var pastable = '';
        var nodeText = sel.startContainer.textContent.replace(/\u00a0/g, " ");
        if (sel.startContainer.textContent === '' || sel.startOffset === 0 || nodeText[sel.startOffset - 1] === ' ') {
          if (e.shiftKey) {
            pastable = '“';
          } else {
            pastable = '‘';
          }
        } else if (nodeText[sel.startOffset - 1] !== ' ') {
          if (e.shiftKey) {
            pastable = '”';
          } else {
            pastable = '’';
          }
        } else {
          pastable = '‘';
        }
        this.medium.pasteHTML(pastable);
      }
    }
  }, {
    key: 'change',
    value: function change(text) {
      if (this.props.onContentChanged) this.props.onContentChanged(text);
    }
  }, {
    key: 'placeCaretAtEnd',
    value: function placeCaretAtEnd() {
      var el = this.dom;
      el.focus();
      if (typeof window.getSelection != "undefined" && typeof document.createRange != "undefined") {
        var range = document.createRange();
        range.selectNodeContents(el);
        range.collapse(false);
        var sel = window.getSelection();
        sel.removeAllRanges();
        sel.addRange(range);
      } else if (typeof document.body.createTextRange != "undefined") {
        var textRange = document.body.createTextRange();
        textRange.moveToElementText(el);
        textRange.collapse(false);
        textRange.select();
      }
    }
  }, {
    key: 'captureReturn',
    value: function captureReturn(e) {
      if (e.which === _keys2.default.ENTER) {
        e.preventDefault();
        if (this.props.captureReturn) {
          this.props.captureReturn();
          this.dom.innerHTML = this.dom.innerHTML.replace('<p><br></p>', '');
          this.props.onContentChanged(this.dom.innerHTML.replace('<p><br></p>', ''));
        }
      }
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement('div', { ref: 'mediumeditor',
        className: 'katap-medium-editor markdown-body',
        options: this.props.options,
        dangerouslySetInnerHTML: { __html: this.state.content },
        contentEditable: true });
    }
  }]);

  return MediumComponent;
}(_react2.default.Component);

exports.default = MediumComponent;


MediumComponent.defaultProps = {
  options: (0, _editoroptions2.default)(),
  enterCapture: false
};