'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _scribeEditor = require('scribe-editor');

var _scribeEditor2 = _interopRequireDefault(_scribeEditor);

var _scribePluginCurlyQuotes = require('scribe-plugin-curly-quotes');

var _scribePluginCurlyQuotes2 = _interopRequireDefault(_scribePluginCurlyQuotes);

var _scribePluginSanitizer = require('scribe-plugin-sanitizer');

var _scribePluginSanitizer2 = _interopRequireDefault(_scribePluginSanitizer);

var _scribePluginFormatterPlainTextConvertNewLinesToHtml = require('scribe-plugin-formatter-plain-text-convert-new-lines-to-html');

var _scribePluginFormatterPlainTextConvertNewLinesToHtml2 = _interopRequireDefault(_scribePluginFormatterPlainTextConvertNewLinesToHtml);

var _scribePluginFormatterHtmlEnsureSemanticElements = require('scribe-plugin-formatter-html-ensure-semantic-elements');

var _scribePluginFormatterHtmlEnsureSemanticElements2 = _interopRequireDefault(_scribePluginFormatterHtmlEnsureSemanticElements);

var _scribePluginSmartLists = require('scribe-plugin-smart-lists');

var _scribePluginSmartLists2 = _interopRequireDefault(_scribePluginSmartLists);

var _scribePluginHeadingCommand = require('scribe-plugin-heading-command');

var _scribePluginHeadingCommand2 = _interopRequireDefault(_scribePluginHeadingCommand);

var _scribeOptions = require('./scribe-options');

var _keys = require('../utils/keys');

var _keys2 = _interopRequireDefault(_keys);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ScribeEditor = function (_React$Component) {
  _inherits(ScribeEditor, _React$Component);

  function ScribeEditor(props) {
    _classCallCheck(this, ScribeEditor);

    var _this = _possibleConstructorReturn(this, (ScribeEditor.__proto__ || Object.getPrototypeOf(ScribeEditor)).call(this, props));

    _this.state = {
      showToolbar: false,
      showLinkInput: false,
      placeholder: true
    };

    _this.scribe = null;
    _this.dom = null;
    _this._updated = false;
    _this.tempRange = null;

    _this.scrollY = -1;

    _this.placeCaretAtEnd = _this.placeCaretAtEnd.bind(_this);
    _this.captureReturn = _this.captureReturn.bind(_this);
    _this.handleCommand = _this.handleCommand.bind(_this);
    _this.onSelect = _this.onSelect.bind(_this);
    _this._onSelect = _this._onSelect.bind(_this);
    _this.handleLink = _this.handleLink.bind(_this);
    _this.handleLinkShortcut = _this.handleLinkShortcut.bind(_this);

    _this.onBlur = function () {
      if (_this.state.showLinkInput) {
        return;
      }
      _this.setState({ showToolbar: false, showLinkInput: false });
    };
    return _this;
  }

  _createClass(ScribeEditor, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      this.dom = _reactDom2.default.findDOMNode(this.refs.scribeeditor);
      this.scribe = new _scribeEditor2.default(this.dom);
      if (!this.props.inline) {
        this.scribe.use((0, _scribePluginSmartLists2.default)());
      }
      this.scribe.use((0, _scribeOptions.linkCommand)());
      this.scribe.use((0, _scribePluginFormatterPlainTextConvertNewLinesToHtml2.default)());
      this.scribe.use((0, _scribePluginCurlyQuotes2.default)());
      this.scribe.use((0, _scribePluginSanitizer2.default)(this.props.options));
      this.scribe.use((0, _scribePluginFormatterHtmlEnsureSemanticElements2.default)());
      this.scribe.use((0, _scribePluginHeadingCommand2.default)(3));
      this.scribe.use((0, _scribeOptions.keyboardPlugin)());
      // this.scribe.use(placeholderPlugin('Write your story...', ReactDOM.findDOMNode(this)));

      if (this.props.inline || this.props.enterCapture) {
        this.scribe.el.addEventListener('keydown', this.captureReturn);
      }
      this.scribe.on('scribe:content-changed', function () {
        if ((0, _scribeOptions.isEditorEmpty)(_this2.scribe)) {
          if (!_this2.state.placeholder) {
            _this2.setState({
              placeholder: true
            });
          }
        } else {
          if (_this2.state.placeholder) {
            _this2.setState({
              placeholder: false
            });
          }
        }
        _this2.props.onContentChanged(_this2.scribe.getHTML());
      });

      this.scribe.setContent(this.props.content);

      if (this.props.onFocus) {
        this.scribe.el.addEventListener('focus', this.props.onFocus);
      }
      this.scribe.el.addEventListener('blur', this.onBlur);

      if (this.props.content.length < 12) {
        this.placeCaretAtEnd();
      }
      this.scribe.el.addEventListener('keydown', this.handleLinkShortcut);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      if (this.props.inline || this.props.enterCapture) {
        this.scribe.el.removeEventListener('keydown', this.captureReturn);
      }
      this.scribe.el.removeEventListener('keydown', this.handleLinkShortcut);
      this.scribe.el.removeEventListener('focus', this.props.onFocus);
      this.scribe.el.removeEventListener('blur', this.onBlur);
      this.scribe.destroy();
      this.dom = null;
      this.scribe = null;
      this.tempRange = null;
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (this._updated) this._updated = false;
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      if (nextState.showToolbar !== this.state.showToolbar || nextState.showLinkInput !== this.state.showLinkInput || nextState.placeholder != this.state.placeholder) {
        return true;
      }
      return false;
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      if (!this.state.showToolbar) {
        return;
      }
      var toolbar = this.refs.toolbar;
      var toolbarBoundary = toolbar.getBoundingClientRect();
      var selection = window.getSelection();
      var range = selection.getRangeAt(0);
      var selectionBoundary = range.getBoundingClientRect();
      var parent = this.dom;
      var parentBoundary = parent.getBoundingClientRect();
      toolbar.style.top = selectionBoundary.top - parentBoundary.top - toolbarBoundary.height - 5 + 'px';
      var widthDiff = selectionBoundary.width - toolbarBoundary.width;
      if (widthDiff >= 0) {
        toolbar.style.left = widthDiff / 2 + 'px';
      } else {
        var left = selectionBoundary.left - parentBoundary.left;
        if (left + toolbarBoundary.width > parentBoundary.width) {
          toolbar.style.right = '0px';
        } else {
          toolbar.style.left = left + widthDiff / 2 + 'px';
        }
      }
    }
  }, {
    key: 'placeCaretAtEnd',
    value: function placeCaretAtEnd() {
      var el = this.dom;
      el.focus();
      if (typeof window.getSelection != "undefined" && typeof document.createRange != "undefined") {
        var range = document.createRange();
        range.selectNodeContents(el);
        range.collapse(false);
        var sel = window.getSelection();
        sel.removeAllRanges();
        sel.addRange(range);
      } else if (typeof document.body.createTextRange != "undefined") {
        var textRange = document.body.createTextRange();
        textRange.moveToElementText(el);
        textRange.collapse(false);
        textRange.select();
      }
    }
  }, {
    key: 'captureReturn',
    value: function captureReturn(e) {
      if (e.ctrlKey || e.shiftKey || e.altKey || e.metaKey) {
        return;
      }
      if (e.which == _keys2.default.ENTER) {
        if (this.props.inline || this.props.enterCapture) {
          e.preventDefault();
        }
        if (this.props.captureReturn) {
          this.props.captureReturn();
        }
      }
    }
  }, {
    key: '_onSelect',
    value: function _onSelect() {
      var selection = new this.scribe.api.Selection();
      // const selection = window.getSelection();
      // const str = selection.toString();
      if (selection.range.collapsed || this.state.showToolbar) {
        this.setState({ showToolbar: false, showLinkInput: false });
      } else {
        this.setState({ showToolbar: true, showLinkInput: false });
      }
    }
  }, {
    key: 'onSelect',
    value: function onSelect(e) {
      var _this3 = this;

      setTimeout(function () {
        _this3._onSelect();
      }, 0);
    }
  }, {
    key: 'handleLink',
    value: function handleLink(e) {
      var _this4 = this;

      if (e.which === _keys2.default.ESC) {
        e.stopPropagation();
        this.scrollY = window.pageYOffset;
        this.setState({
          showLinkInput: false,
          showToolbar: true
        }, function () {
          var selection = new _this4.scribe.api.Selection();
          _this4.scribe.el.focus();
          selection.selection.removeAllRanges();
          selection.selection.addRange(_this4.tempRange);
          if (_this4.scrollY !== -1) {
            window.scrollTo(0, _this4.scrollY);
            _this4.scrollY = -1;
          }
        });
      } else if (e.which === _keys2.default.ENTER) {
        e.preventDefault();
        e.stopPropagation();
        this.scrollY = window.pageYOffset;
        var link = e.target.value;
        var selection = new this.scribe.api.Selection();
        this.scribe.el.focus();
        selection.selection.removeAllRanges();
        if (this.scrollY !== -1) {
          window.scrollTo(0, this.scrollY);
          this.scrollY = -1;
        }
        selection.selection.addRange(this.tempRange);
        if (link.length < 1) {
          var command = this.scribe.getCommand('unlink');
          command.execute('unlink');
          this.setState({
            showLinkInput: false,
            showToolbar: true
          });
        } else {
          // this.addLink(link);
          var _command = this.scribe.getCommand('setLink');
          _command.execute(link);
          this.setState({
            showLinkInput: false,
            showToolbar: true
          });
        }
      }
    }
  }, {
    key: 'handleLinkShortcut',
    value: function handleLinkShortcut(e) {
      if (e.which === 75 && (e.ctrlKey || e.metaKey)) {
        e.preventDefault();
        var selection = new this.scribe.api.Selection();
        if (!selection.range.collapsed) {
          this.handleCommand('link');
        }
      }
    }
  }, {
    key: 'handleCommand',
    value: function handleCommand(cmd) {
      var _this5 = this;

      if (cmd === 'link') {
        if (this.state.showLinkInput) {
          this.setState({ showLinkInput: false, showToolbar: true });
        } else {
          var command = this.scribe.getCommand('setLink');
          var currentLink = command.getCurrentLink();
          this.setState({ showLinkInput: true, showToolbar: true }, function () {
            _this5.tempRange = new _this5.scribe.api.Selection().range;
            setTimeout(function () {
              _this5.refs.linkinput.focus();
              _this5.refs.linkinput.select();
              _this5.refs.linkinput.value = currentLink;
            }, 0);
          });
        }
      } else {
        var _command2 = this.scribe.getCommand(cmd);
        _command2.execute(cmd);
      }
    }
  }, {
    key: 'splitAtCursor',
    value: function splitAtCursor() {
      var cmd = this.scribe.getCommand('insertHTML');
      cmd.execute(this.scribe._htmlFormatterFactory.format('<p><br></p>'));
      return this.scribe.getHTML();
    }
  }, {
    key: 'render',
    value: function render() {
      var _this6 = this;

      return _react2.default.createElement(
        'div',
        { className: 'katap-scribe-container' },
        this.state.showToolbar ? _react2.default.createElement(
          'div',
          { className: 'katap-scribe-toolbar' + (this.state.showLinkInput ? ' katap-link-inp-visible' : ''), ref: 'toolbar' },
          !this.state.showLinkInput ? _scribeOptions.toolbarButtons.map(function (btn) {
            var _scribe = _this6.scribe;
            var className = 'katap-inline-toolbar-btn katap-inline-btn-' + btn.command;
            return _react2.default.createElement(
              'button',
              { className: className, key: btn.command, title: btn.command.toUpperCase(), onMouseDown: function onMouseDown() {
                  return _this6.handleCommand(btn.command);
                } },
              _react2.default.createElement('i', { className: "fa fa-" + btn.icon })
            );
          }) : _react2.default.createElement('input', {
            ref: 'linkinput',
            type: 'text',
            className: 'katap-scribe-link-input',
            placeholder: 'Paste and ENTER',
            onKeyDown: this.handleLink
          })
        ) : null,
        _react2.default.createElement('div', { ref: 'scribeeditor',
          className: 'katap-medium-editor markdown-body',
          onKeyUp: this.onSelect,
          onMouseUp: this.onSelect,
          contentEditable: true }),
        this.state.placeholder ? _react2.default.createElement(
          'div',
          { className: 'scribe-plugin-placeholder', style: { top: 0, left: 2 } },
          this.props.placeholder
        ) : null
      );
    }
  }]);

  return ScribeEditor;
}(_react2.default.Component);

exports.default = ScribeEditor;


ScribeEditor.defaultProps = {
  options: _scribeOptions.baseOptions,
  inline: false,
  placeholder: 'Write your story...'
};