'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _action = require('./utils/action');

var _action2 = _interopRequireDefault(_action);

var _blockcontrol = require('./components/blockcontrol');

var _blockcontrol2 = _interopRequireDefault(_blockcontrol);

var _toolbar = require('./components/toolbar');

var _toolbar2 = _interopRequireDefault(_toolbar);

var _utils = require('./utils');

var _blocks = require('./blocks');

var _blocks2 = _interopRequireDefault(_blocks);

var _embeds = require('./blocks/embeds');

var _embeds2 = _interopRequireDefault(_embeds);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var splitterString = '<p>==</p>';

var initialState = {
  blocks: []
};

var Editor = function (_React$Component) {
  _inherits(Editor, _React$Component);

  function Editor(props) {
    _classCallCheck(this, Editor);

    var _this = _possibleConstructorReturn(this, (Editor.__proto__ || Object.getPrototypeOf(Editor)).call(this, props));

    _this.handleBlockAction = _this.handleBlockAction.bind(_this);
    _this.getBlocks = _this.getBlocks.bind(_this);
    _this.addBlock = _this.addBlock.bind(_this);
    _this.contentChange = _this.contentChange.bind(_this);
    _this.getToolbar = _this.getToolbar.bind(_this);
    _this.renderBlocks = _this.renderBlocks.bind(_this);
    _this.splitBlock = _this.splitBlock.bind(_this);
    return _this;
  }

  _createClass(Editor, [{
    key: 'splitBlock',
    value: function splitBlock(position) {
      var splitter = this.props.splitter;
      var newBlocks = this.props.blocks;
      var currentBlock = newBlocks[position];

      if (currentBlock.type !== _blocks2.default.text.Name) {
        return;
      }

      var splitterRegex = /((?:\<[a-zA-Z\d]{1,}\>){1,2}\<br\>(?:\<\/[a-zA-Z\d]{1,}\>){1,2})/gi;
      var stringsFix = currentBlock.data.replace(splitterRegex, splitter);
      var stringsTmp = stringsFix.split(splitter);

      var strings = [];
      stringsTmp.forEach(function (str) {
        if (str !== "") {
          strings.push(str);
        }
      });
      newBlocks.splice(position, 1);
      var pos = position;
      var newBlock = {};
      strings.forEach(function (str) {
        newBlock = {
          type: _blocks2.default.text.Name,
          data: str,
          key: (0, _utils.uuid)()
        };
        newBlocks.splice(pos++, 0, newBlock);
      });
      this.props.onChange(newBlocks);
    }
  }, {
    key: 'handleBlockAction',
    value: function handleBlockAction(action, position) {
      var newBlocks = this.props.blocks;
      var Blocks = this.props.availableBlocks;
      if (action === _action2.default.REMOVE) {
        if (Blocks[newBlocks[position].type].isEmpty(newBlocks[position].data) || confirm('Are you sure?')) {
          newBlocks.splice(position, 1);
        } else {
          return;
        }
      } else if (action === _action2.default.UP) {
        newBlocks.splice(position - 1, 2, newBlocks[position], newBlocks[position - 1]);
      } else if (action === _action2.default.DOWN) {
        newBlocks.splice(position, 2, newBlocks[position + 1], newBlocks[position]);
      }
      this.props.onChange(newBlocks);
    }
  }, {
    key: 'getBlocks',
    value: function getBlocks() {
      console.warn('This function will be deprecated in the next version.');
      return this.props.blocks;
    }
  }, {
    key: 'addBlock',
    value: function addBlock(type, position) {
      var blocks = this.props.blocks;
      if (position < -1 || position > blocks.length) {
        return;
      }
      var newBlocks = this.props.blocks;
      var Blocks = this.props.availableBlocks;
      if (!Blocks[type]) {
        return;
      }
      if (Blocks[type].maximumBlocks !== 0) {
        var blocksOfType = 0;
        blocks.forEach(function (block, index) {
          if (block.type === type) {
            blocksOfType++;
          }
        });
        if (blocksOfType >= Blocks[type].maximumBlocks) {
          return;
        }
      }
      var newBlock = {
        type: type,
        data: Blocks[type].Empty(),
        key: (0, _utils.uuid)()
      };
      newBlocks.splice(position + 1, 0, newBlock);
      this.props.onChange(newBlocks);
    }
  }, {
    key: 'contentChange',
    value: function contentChange(position, content) {
      var newBlocks = this.props.blocks;
      newBlocks[position].data = content;
      this.props.onChange(newBlocks);
    }
  }, {
    key: 'getToolbar',
    value: function getToolbar(index) {
      return _react2.default.createElement(_blockcontrol2.default, {
        blockAction: this.handleBlockAction,
        position: index,
        className: 'katap-control-toolbar katap-clearfix',
        length: this.props.blocks.length });
    }
  }, {
    key: 'renderBlocks',
    value: function renderBlocks() {
      var self = this;
      var blocks = this.props.blocks;
      var Blocks = this.props.availableBlocks;
      if (blocks.length < 1) {
        return _react2.default.createElement(_toolbar2.default, {
          position: 0,
          addBlock: this.addBlock,
          availableBlocks: Blocks });
      }
      var rndr = blocks.map(function (block, index) {

        var Block = Blocks[block.type].React;
        if (!Blocks[block.type]) {
          return null;
        }

        return _react2.default.createElement(
          'div',
          { key: block.key, className: 'katap-container' },
          self.getToolbar(index),
          _react2.default.createElement(Block, _extends({
            ref: "block" + index,
            position: index,
            content: block.data,
            addBlock: self.addBlock,
            onContentChanged: self.contentChange,
            UploadUrl: self.props.UploadUrl,
            EmbedTypes: self.props.EmbedTypes,
            splitBlock: self.splitBlock
          }, self.props)),
          _react2.default.createElement(_toolbar2.default, { position: index, addBlock: self.addBlock, availableBlocks: Blocks })
        );
      });
      return rndr;
    }
  }, {
    key: 'render',
    value: function render() {
      if (this.props.blocks.length > 0) {
        return _react2.default.createElement(
          'div',
          { className: 'katap-listing' },
          _react2.default.createElement(_toolbar2.default, {
            position: -1,
            addBlock: this.addBlock,
            availableBlocks: this.props.availableBlocks }),
          this.renderBlocks()
        );
      }
      return _react2.default.createElement(
        'div',
        { className: 'katap-listing' },
        this.renderBlocks()
      );
    }
  }]);

  return Editor;
}(_react2.default.Component);

exports.default = Editor;


Editor.defaultProps = {
  availableBlocks: _blocks2.default,
  EmbedTypes: _embeds2.default,
  getBlocks: function getBlocks() {
    return [];
  },
  UploadUrl: '',
  splitter: splitterString
};